if GetBagInfo == nil then
    function GetBagInfo(bagId)
        return "/esoui/art/icons/icon_missing.dds", GetBagSize(bagId)
    end
end

if GetShortAllianceName == nil then
    function GetShortAllianceName(alliance)
        return GetAllianceName(alliance)
    end
end

KEYBIND_STRIP_FRAGMENT = KEYBIND_STRIP_FRAGMENT or KEYBIND_STRIP_FADE_FRAGMENT

local _GetItemArmorType = GetItemArmorType 
function GetItemArmorType(arg, ...)
    if type(arg) == "string" then
        return GetItemLinkArmorType(arg, ...)
    else
        return _GetItemArmorType(arg, ...)
    end  
end

local _GetItemWeaponType = GetItemWeaponType 
function GetItemWeaponType(arg, ...)
    if type(arg) == "string" then
        return GetItemLinkWeaponType(arg, ...)
    else
        return _GetItemWeaponType(arg, ...)
    end  
end


--Changed/removed functions in Update 4
local _GetAchievementItemLink = GetAchievementItemLink
function GetAchievementItemLink(arg1, arg2, arg3)
    return _GetAchievementItemLink(arg1, arg3 or arg2)
end

if GetAchievementRewardInfo == nil then
    function GetAchievementRewardInfo(achievementId, rewardIndex)
        local rewards = {}

        local points = GetAchievementRewardPoints(achievementId)
        table.insert(rewards, {ACHIEVEMENT_REWARD_TYPE_POINTS, points})

        local hasRewardItem, itemName, iconTextureName, quality = GetAchievementRewardItem(achievementId)
        if hasRewardItem then
            table.insert(rewards, {ACHIEVEMENT_REWARD_TYPE_ITEM, itemName, iconTextureName, quality})
        end

        local hasRewardTitle, titleName = GetAchievementRewardTitle(achievementId)
        if hasRewardTitle then
            table.insert(rewards, {ACHIEVEMENT_REWARD_TYPE_TITLE, titleName})
        end

        local hasRewardDye, dyeIndex = GetAchievementRewardDye(achievementId)
        if hasRewardDye then
            table.insert(rewards, {ACHIEVEMENT_REWARD_TYPE_DYE, dyeIndex})
        end
      
        return unpack(rewards[rewardIndex])
    end
end

local _IsSmithingStyleKnown = IsSmithingStyleKnown
function IsSmithingStyleKnown(styleItemIndex, patternIndex)
    return _IsSmithingStyleKnown(styleItemIndex, patternIndex or 1)
end

GetNumLastCraftingResultItems = GetNumLastCraftingResultItems or GetNumLastCraftingResultItemsAndPenalty


--Changed/removed functions in Update 5
GetNumHeraldryItems = GetNumHeraldryItems or GetNumGuildSpecificItems
GetHeraldryItemInfo = GetHeraldryItemInfo or GetGuildSpecificItemInfo
BuyHeraldryItem = BuyHeraldryItem or BuyGuildSpecificItem
GetHeraldryItemLink = GetHeraldryItemLink or GetGuildSpecificItemLink

IsThirdAlchemySlotUnlocked = IsThirdAlchemySlotUnlocked or ZO_Alchemy_IsThirdAlchemySlotUnlocked

local function AddDataTable(control)
    control.data = control.data or setmetatable({}, {__index = control})
end
ZO_PreHook("ZO_OptionsWindow_InitializeControl", AddDataTable)
ZO_PreHook("IsControlAnOption", AddDataTable)
ZO_PreHook("ZO_Options_UpdateOption", AddDataTable)
ZO_PreHook("ZO_Options_SetupSlider", AddDataTable)
ZO_PreHook("ZO_Options_SetupDropdown", AddDataTable)
ZO_PreHook("ZO_Options_SetupCheckBox", AddDataTable)
ZO_PreHook("ZO_Options_OnMouseEnter", function(control)
    AddDataTable(control)
    if (control.tooltipText and control.data.tooltipText == nil) then
        control.data.tooltipText = control.tooltipText
    end
end)

if not ZO_OptionsWindow_LoadDefaults then
    ZO_OptionsWindow_LoadDefaults = function()
        KEYBOARD_OPTIONS:LoadDefaults()
    end
end
if not ZO_OptionsWindow_UpdatePanelOptions then
    ZO_OptionsWindow_UpdatePanelOptions = function(panelIndex, saveOptions)
        KEYBOARD_OPTIONS:UpdatePanelOptions(panelIndex, saveOptions)
    end
end
if not ZO_OptionsWindow_UpdateAllPanelOptions then
    ZO_OptionsWindow_UpdateAllPanelOptions = function(saveOptions)
        KEYBOARD_OPTIONS:UpdateAllPanelOptions(saveOptions)
    end
end
if not ZO_OptionsWindow_ChangePanels then
    ZO_OptionsWindow_ChangePanels = function(panel, hooksCall)
        if hooksCall == true then return end
        KEYBOARD_OPTIONS:ChangePanels(panel)
    end
    ZO_PreHook(ZO_SharedOptions, "ChangePanels", function(self, panel) ZO_OptionsWindow_ChangePanels(panel, true) end) --call functions hooked to ZO_OptionsWindow_ChangePanels (works only for pre-hook, but it should be enough) 
end
 
--Changed/removed functions in Update 6
GetMaxMountLevel = GetMaxMountLevel or GetMaxRidingTraining
GetTimeUntilMountCanBeFed = GetTimeUntilMountCanBeFed or GetTimeUntilCanBeTrained
PlayEmote = PlayEmote or PlayEmoteByIndex

local _GetAchievementCategoryInfo = GetAchievementCategoryInfo
function GetAchievementCategoryInfo(categoryIndex)
    local name, numSubCatgories, numAchievements, earnedPoints, totalPoints, hidesPoints = _GetAchievementCategoryInfo(categoryIndex) 
    local normalIcon, pressedIcon, mouseoverIcon = GetAchievementCategoryKeyboardIcons(categoryIndex)
    return name, numSubCatgories, numAchievements, earnedPoints, totalPoints, hidesPoints, normalIcon, pressedIcon, mouseoverIcon
end


EVENT_MANAGER:RegisterForEvent("CompatibilityTool", EVENT_ADD_ON_LOADED, function(event, name)
    if (name):find("^ZO_") then return end
    EVENT_MANAGER:UnregisterForEvent("CompatibilityTool", event)
   
    local inventory_mt = {}
    function inventory_mt.__index(self, key)
        if key == "numSlots" then
            return GetBagSize(self.backingBag)
        elseif key == "numUsedSlots" then
            return GetNumBagUsedSlots(self.backingBag)
        end
    end
   
    for i, inventory in pairs(PLAYER_INVENTORY.inventories) do
        setmetatable(inventory, inventory_mt)
    end
end)
